// @bun
var __defProp = Object.defineProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, {
      get: all[name],
      enumerable: true,
      configurable: true,
      set: (newValue) => all[name] = () => newValue
    });
};

// src/arr.ts
var exports_arr = {};
__export(exports_arr, {
  zScore: () => {
    {
      return zScore;
    }
  },
  variance: () => {
    {
      return variance;
    }
  },
  uniqueBy: () => {
    {
      return uniqueBy;
    }
  },
  unique: () => {
    {
      return unique;
    }
  },
  uniq: () => {
    {
      return uniq;
    }
  },
  toArray: () => {
    {
      return toArray;
    }
  },
  sum: () => {
    {
      return sum;
    }
  },
  standardDeviation: () => {
    {
      return standardDeviation;
    }
  },
  shuffle: () => {
    {
      return shuffle;
    }
  },
  sample: () => {
    {
      return sample;
    }
  },
  remove: () => {
    {
      return remove;
    }
  },
  range: () => {
    {
      return range;
    }
  },
  product: () => {
    {
      return product;
    }
  },
  percentile: () => {
    {
      return percentile;
    }
  },
  partition: () => {
    {
      return partition;
    }
  },
  move: () => {
    {
      return move;
    }
  },
  mode: () => {
    {
      return mode;
    }
  },
  min: () => {
    {
      return min;
    }
  },
  mergeArrayable: () => {
    {
      return mergeArrayable;
    }
  },
  median: () => {
    {
      return median;
    }
  },
  max: () => {
    {
      return max;
    }
  },
  last: () => {
    {
      return last;
    }
  },
  interquartileRange: () => {
    {
      return interquartileRange;
    }
  },
  flatten: () => {
    {
      return flatten;
    }
  },
  doesNotContain: () => {
    {
      return doesNotContain;
    }
  },
  covariance: () => {
    {
      return covariance;
    }
  },
  containsOnly: () => {
    {
      return containsOnly;
    }
  },
  containsNone: () => {
    {
      return containsNone;
    }
  },
  containsAny: () => {
    {
      return containsAny;
    }
  },
  containsAll: () => {
    {
      return containsAll;
    }
  },
  contains: () => {
    {
      return contains;
    }
  },
  clampArrayRange: () => {
    {
      return clampArrayRange;
    }
  },
  avg: () => {
    {
      return avg;
    }
  },
  average: () => {
    {
      return average;
    }
  },
  at: () => {
    {
      return at;
    }
  }
});

// src/helpers.ts
import {clamp} from "@stacksjs/utils";
function toArray(array) {
  array = array ?? [];
  return Array.isArray(array) ? array : [array];
}
function flatten(array) {
  return toArray(array).flat(1);
}
function mergeArrayable(...args) {
  return args.flatMap((i) => toArray(i));
}
function partition(array, ...filters) {
  const result = Array.from({ length: filters.length + 1 }).fill(null).map(() => []);
  array.forEach((e, idx, arr) => {
    let i = 0;
    for (const filter of filters) {
      if (filter(e, idx, arr)) {
        result[i].push(e);
        return;
      }
      i += 1;
    }
    result[i].push(e);
  });
  return result;
}
function uniq(array) {
  return Array.from(new Set(array));
}
function unique(array) {
  return uniq(array);
}
function uniqueBy(array, equalFn) {
  return array.reduce((acc, cur) => {
    const index = acc.findIndex((item) => equalFn(cur, item));
    if (index === -1)
      acc.push(cur);
    return acc;
  }, []);
}
function last(array) {
  return at(array, -1);
}
function remove(array, value) {
  if (!array)
    return false;
  const index = array.indexOf(value);
  if (index >= 0) {
    array.splice(index, 1);
    return true;
  }
  return false;
}
function at(array, index) {
  const len = array.length;
  if (!len)
    return;
  if (index < 0)
    index += len;
  return array[index];
}
function move(array, from, to) {
  const len = array.length;
  if (!len)
    return [];
  if (from < 0)
    from += len;
  if (to < 0)
    to += len;
  const item = array.splice(from, 1)[0];
  array.splice(to, 0, item);
  return array;
}
function clampArrayRange(arr, n) {
  return clamp(n, 0, arr.length - 1);
}
function sample(arr, count) {
  return Array.from({ length: count }, (_) => arr[Math.round(Math.random() * (arr.length - 1))]);
}
function shuffle(array) {
  for (let i = array.length - 1;i > 0; i--) {
    const j = Math.floor(Math.random() * (i + 1));
    [array[i], array[j]] = [array[j], array[i]];
  }
  return array;
}
// src/math.ts
function average(arr) {
  return sum(arr) / arr.length;
}
function avg(arr) {
  return average(arr);
}
function median(arr) {
  if (arr.length === 0)
    throw new Error("Cannot compute median of an empty array");
  const sorted = [...arr].sort((a, b) => a - b);
  const mid = Math.floor(sorted.length / 2);
  let medianValue;
  if (sorted.length % 2 !== 0)
    medianValue = sorted[mid];
  else
    medianValue = (sorted[mid] + sorted[mid - 1]) / 2;
  return medianValue;
}
function mode(arr) {
  return arr.sort((a, b) => arr.filter((v) => v === a).length - arr.filter((v) => v === b).length).pop();
}
function sum(array) {
  return array.reduce((acc, cur) => acc + cur, 0);
}
function product(array) {
  return array.reduce((acc, cur) => acc * cur, 1);
}
function min(array) {
  return Math.min(...array);
}
function max(array) {
  return Math.max(...array);
}
function range(array) {
  return max(array) - min(array);
}
function variance(array) {
  const mean = average(array);
  return average(array.map((num) => (num - mean) ** 2));
}
function standardDeviation(array) {
  return Math.sqrt(variance(array));
}
function zScore(array, num) {
  return (num - average(array)) / standardDeviation(array);
}
function percentile(array, num) {
  return array.filter((n) => n < num).length / array.length;
}
function interquartileRange(array) {
  const q1 = median(array.slice(0, Math.floor(array.length / 2)));
  const q3 = median(array.slice(Math.ceil(array.length / 2)));
  return q3 - q1;
}
function covariance(array1, array2) {
  if (array1.length !== array2.length)
    throw new Error("Arrays must have the same length");
  const mean1 = average(array1);
  const mean2 = average(array2);
  return average(array1.map((num1, i) => (num1 - mean1) * (array2[i] - mean2)));
}
// src/contains.ts
function contains(needle, haystack) {
  return haystack.some((hay) => needle.includes(hay));
}
function containsAll(needles, haystack) {
  return needles.every((needle) => contains(needle, haystack));
}
function containsAny(needles, haystack) {
  return needles.some((needle) => contains(needle, haystack));
}
function containsNone(needles, haystack) {
  return !containsAny(needles, haystack);
}
function containsOnly(needles, haystack) {
  return containsAll(haystack, needles);
}
function doesNotContain(needle, haystack) {
  return !contains(needle, haystack);
}
// src/macro.ts
var Arr = {
  contains(needle, haystack) {
    return contains(needle, haystack);
  },
  containsAll(needles, haystack) {
    return containsAll(needles, haystack);
  },
  containsAny(needles, haystack) {
    return containsAny(needles, haystack);
  },
  containsNone(needles, haystack) {
    return containsNone(needles, haystack);
  },
  containsOnly(needles, haystack) {
    return containsOnly(needles, haystack);
  },
  doesNotContain(needle, haystack) {
    return doesNotContain(needle, haystack);
  },
  toArray(array) {
    return toArray(array);
  },
  flatten(array) {
    return flatten(array);
  },
  mergeArrayable(...args) {
    return mergeArrayable(...args);
  },
  partition(array, filter) {
    return partition(array, filter);
  },
  random(arr, count = 1) {
    return sample(arr, count).filter((item) => item != null);
  },
  sample(arr, count = 1) {
    const sampleArr = sample(arr, count);
    return sampleArr.filter((item) => item !== undefined);
  },
  unique(arr) {
    return uniq(arr);
  },
  uniqueBy(arr, equalFn) {
    return uniqueBy(arr, equalFn);
  },
  last(arr) {
    return last(arr);
  },
  remove(arr, value) {
    return remove(arr, value);
  },
  at(arr, index) {
    return at(arr, index);
  },
  range(arr) {
    return range(arr);
  },
  move(arr, from, to) {
    return move(arr, from, to);
  },
  clampArrayRange(arr, n) {
    return clampArrayRange(arr, n);
  },
  shuffle(arr) {
    return shuffle(arr);
  },
  sum(arr) {
    return sum(arr);
  },
  average(arr) {
    return average(arr);
  },
  avg(arr) {
    return average(arr);
  },
  median(arr) {
    return median(arr);
  },
  mode(arr) {
    return mode(arr);
  }
};
export {
  zScore,
  variance,
  uniqueBy,
  unique,
  uniq,
  toArray,
  sum,
  standardDeviation,
  shuffle,
  sample,
  remove,
  range,
  product,
  percentile,
  partition,
  move,
  mode,
  min,
  mergeArrayable,
  median,
  max,
  last,
  interquartileRange,
  flatten,
  doesNotContain,
  covariance,
  containsOnly,
  containsNone,
  containsAny,
  containsAll,
  contains,
  clampArrayRange,
  avg,
  average,
  at,
  exports_arr as arr,
  Arr
};
